﻿; // MegaMan by Dao Van Trong - Trong.LIVE //

Opt("GUICloseOnESC", 0)
Opt("TrayOnEventMode", 1)
Opt("TrayMenuMode", 1 + 8 + 2)
;~ Opt("MustDeclareVars", 1)

#include "GEngin.au3"

Global $AutoName = "MegaMan", $AutoPause = 0, $CharWidth = 70, $CharHeight = 70, $CharHeightDif = 2, $CharBornPos[2] = [50, -100], $CharPos[4], $CharOnGround = False, $CharStand = True, $CharRight = True, $CharLeft = False, $CharDropSpeed = 20, $CharMoveSpeed = 10, $CharStandBy = 50, $CharStepShowUp[3] = [0, 21, 22], $CharStandRight[3] = [21, 24, 4], $CharStandLeft[3] = [21, 24, 4], $CharMoveRight[3] = [27, 40, 13], $CharMoveLeft[3] = [27, 40, 13]
Global $MegaMan_IMG = @ScriptDir& "\Rockman.png", $MegaMan_width = 2870, $MegaMan_height = 140, $MegaMan_obj, $MegaMan_showup, $MegaMan_standleft, $MegaMan_standright, $MegaMan_moveleft, $MegaMan_moveright
Global $StartBarTitle = '[CLASS:Shell_TrayWnd]'
Global $Ground = WinGetPos($StartBarTitle)
Global $TrayOnTop = TrayCreateItem("Not On-Top")
TrayItemSetOnEvent($TrayOnTop, "FCharSetOnTop")
Global $TrayReborn = TrayCreateItem("Reborn")
TrayItemSetOnEvent($TrayReborn, "FCharReborn")
TrayCreateItem("")
Global $TrayExit = TrayCreateItem("Exit")
TrayItemSetOnEvent($TrayExit, "FAutoEnd")
TraySetState()
_GEng_Start($AutoName, $CharWidth, $CharHeight, $CharBornPos[0], $CharBornPos[1], 0x80000000 + 0x0080, 0x00080000 + 0x00000080 + 0x00000100)

FCharOnTop()
FAutoStart()

While 1
	Sleep(72)
	FAutoPause()
	FCharGetInfo()
	FCharLiving()
	_GEng_Sprite_Draw($MegaMan_obj)
	_GEng_ScrUpdatePNG()
WEnd

;~ Exit
;~ FAutoEnd()
;~ FCharSetOnTop()
;~ FCharReborn()
#Region
Func FAutoStart()
	FCreateChar()
	FCharOnTop()
EndFunc   ;==>FAutoStart
Func FAutoEnd()
	_GEng_Shutdown()
	Exit
EndFunc   ;==>FAutoEnd
Func FAutoPause()
	If Not $AutoPause Then Return
	While $AutoPause
		Sleep(10)
	WEnd
EndFunc   ;==>FAutoPause
Func FCreateChar()
	Local $MegaMan_
	$MegaMan_ = _GEng_ImageLoad($MegaMan_IMG, $MegaMan_width, $MegaMan_height)
	$MegaMan_obj = _GEng_Sprite_Create()
	$MegaMan_showup = _GEng_Anim_Create()
	For $i = $CharStepShowUp[0] To $CharStepShowUp[1]
		_GEng_Anim_FrameAdd($MegaMan_showup, $MegaMan_, 70, $CharWidth * $i, 0, $CharWidth, $CharHeight)
	Next
	$MegaMan_standright = _GEng_Anim_Create()
	_GEng_Anim_FrameAdd($MegaMan_standright, $MegaMan_, 3000, $CharWidth * $CharStandRight[0], 0, $CharWidth, $CharHeight)
	For $i = $CharStandRight[0] + 1 To $CharStandRight[1]
		_GEng_Anim_FrameAdd($MegaMan_standright, $MegaMan_, 70, $CharWidth * $i, 0, $CharWidth, $CharHeight)
	Next
	$MegaMan_standleft = _GEng_Anim_Create()
	_GEng_Anim_FrameAdd($MegaMan_standleft, $MegaMan_, 3000, $CharWidth * $CharStandLeft[0], 71, $CharWidth, $CharHeight)
	For $i = $CharStandLeft[0] + 1 To $CharStandLeft[1]
		_GEng_Anim_FrameAdd($MegaMan_standleft, $MegaMan_, 70, $CharWidth * $i, 71, $CharWidth, $CharHeight)
	Next
	$MegaMan_moveright = _GEng_Anim_Create()
	For $i = $CharMoveRight[0] To $CharMoveRight[1]
		_GEng_Anim_FrameAdd($MegaMan_moveright, $MegaMan_, 75, $CharWidth * $i, 0, $CharWidth, $CharHeight)
	Next
	$MegaMan_moveleft = _GEng_Anim_Create()
	For $i = $CharMoveLeft[0] To $CharMoveLeft[1]
		_GEng_Anim_FrameAdd($MegaMan_moveleft, $MegaMan_, 75, $CharWidth * $i, 71, $CharWidth, $CharHeight)
	Next
	_GEng_Sprite_Animate($MegaMan_obj, $MegaMan_showup)
EndFunc   ;==>FCreateChar
Func FCharGetInfo()
	$CharPos = WinGetPos($__GEng_hGui)
	$CharPos[1] = $CharPos[1] + $CharPos[3] - $CharHeightDif
EndFunc   ;==>FCharGetInfo
Func FCharLiving()
	If FCharDropDown() Then
		$CharOnGround = True
	EndIf
	FCharStand()
	FCharMoving()
	If Not Random(0, 5) Then GUISetState(@SW_RESTORE, $__GEng_hGui)
EndFunc   ;==>FCharLiving
Func FCharMoving()
	If Not $CharOnGround Then Return
	Local $Pos, $CharPosOld
	$Pos = MouseGetPos()
	$CharPosOld = $CharPos
	If ($Pos[0] - $CharPos[0]) > $CharStandBy + $CharWidth Then
		If $CharStand Then _GEng_Sprite_AnimRewind($MegaMan_obj, 1)
		If $CharLeft Then _GEng_Sprite_AnimRewind($MegaMan_obj, 1)
		_GEng_Sprite_Animate($MegaMan_obj, $MegaMan_moveright)
		$CharPos[0] += $CharMoveSpeed
		$CharRight = True
		$CharLeft = False
	ElseIf ($CharPos[0] - $Pos[0]) > $CharStandBy Then
		If $CharStand Then _GEng_Sprite_AnimRewind($MegaMan_obj, 1)
		If $CharRight Then _GEng_Sprite_AnimRewind($MegaMan_obj, 1)
		_GEng_Sprite_Animate($MegaMan_obj, $MegaMan_moveleft)
		$CharPos[0] -= $CharMoveSpeed
		$CharRight = False
		$CharLeft = True
	Else
		If Not $CharStand Then _GEng_Sprite_AnimRewind($MegaMan_obj, 1)
		$CharStand = True
		Return False
	EndIf
	WinMove($__GEng_hGui, '', $CharPos[0], $CharPos[1] - $CharPos[3] + $CharHeightDif)
	$CharStand = False
	Return True
EndFunc   ;==>FCharMoving
Func FCharStand()
	If Not $CharOnGround Or Not $CharStand Then Return
	If ($CharRight) Then
		_GEng_Sprite_Animate($MegaMan_obj, $MegaMan_standright)
	ElseIf ($CharLeft) Then
		_GEng_Sprite_Animate($MegaMan_obj, $MegaMan_standleft)
	EndIf
EndFunc   ;==>FCharStand
Func FCharDropDown()
	If $CharOnGround Then Return
	If $CharPos[1] < $Ground[1] Then $CharPos[1] += Ceiling(($Ground[1] - $CharPos[1]) / $CharDropSpeed + 10)
	If $CharPos[1] > $Ground[1] Then $CharPos[1] = $Ground[1]
	WinMove($__GEng_hGui, '', $CharPos[0], $CharPos[1] - $CharPos[3] + $CharHeightDif)
	If (($Ground[1] - $CharPos[1]) < 10) Then
		If _GEng_Sprite_Animate($MegaMan_obj, $MegaMan_showup, $CharStepShowUp[2]) == -1 Then
			_GEng_Sprite_AnimRewind($MegaMan_obj, 1)
			Return True
		EndIf
	EndIf
	Return False
EndFunc   ;==>FCharDropDown
Func FCharOnTop($Top = 1)
	WinSetOnTop($__GEng_hGui, '', $Top)
EndFunc   ;==>FCharOnTop
Func FCharSetOnTop()
	Local $Text
	$Text = TrayItemGetText($TrayOnTop)
	If $Text == 'Set On-Top' Then
		FCharOnTop(1)
		TrayItemSetText($TrayOnTop, "Not On-Top")
	Else
		FCharOnTop(0)
		TrayItemSetText($TrayOnTop, "Set On-Top")
	EndIf
EndFunc   ;==>FCharSetOnTop
Func FCharReborn()
	$CharOnGround = False
	$CharRight = True
	$CharLeft = False
	_GEng_Sprite_AnimRewind($MegaMan_obj, 1)
	_GEng_Sprite_Animate($MegaMan_obj, $MegaMan_showup)
	WinMove($__GEng_hGui, '', $CharBornPos[0], $CharBornPos[1])
EndFunc   ;==>FCharReborn
#EndRegion